/**
 * AbstractExpression.java
 *
 * File generated from the XValidator4::AbstractExpression uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.*;
import net.ihe.gazelle.xvalidation.core.report.Error;
import net.ihe.gazelle.xvalidation.core.xpath.XpathUtils;
import org.w3c.dom.Node;

import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.Map;

import static net.ihe.gazelle.xvalidation.core.model.Level.ERROR;

/**
 * Description of the class AbstractExpression.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AbstractExpression")
@XmlRootElement(name = "AbstractExpression")
@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@Table(name = "xval_expression", schema = "public")
@SequenceGenerator(name = "xval_expression_sequence", sequenceName = "xval_expression_id_seq", allocationSize = 1)
@DiscriminatorValue("abstractExpression")
public abstract class AbstractExpression implements CommonOperations {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private static int generalFakeId = 0;
	private transient int fakeId;

	@Id
	@Column(name = "id", nullable = false, unique = true)
	@GeneratedValue(generator = "xval_expression_sequence", strategy = GenerationType.SEQUENCE)
	@XmlTransient
	private Integer id;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public AbstractExpression() {
		super();
		synchronized (AbstractExpression.class) {
			this.fakeId = generalFakeId++;
		}
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "AbstractExpression", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
	
	public int getFakeId() {
		return fakeId;
	}

	public abstract AbstractExpression createCopy();
    public abstract Notification evaluate(Map<String, Node> files, ValidatorConfiguration configuration, Level level);

    public Notification newNotificationForLevel(Level level){
    	if (level == null){
    		return new Report();
		}
		switch (level) {
			case ERROR:
				return new Error();
			case INFO:
				return new Info();
			case WARNING:
				return new Warning();
			default:
				return new Report();
		}
	}

	protected Notification abort(String reason, Locator locator, String xpathReport){
		Aborted notification = new Aborted();
		notification.setReason(reason);
		notification.setXpathReport(xpathReport);
		if (locator != null){
			notification.addProcessedInput(locator.toString());
		}
		return notification;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + fakeId;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AbstractExpression other = (AbstractExpression) obj;
		if (fakeId != other.fakeId) {
			return false;
		}
		return true;
	}
}